

public class TamponEntiers {
    private int[] tab;
    private int active_size;
    private int nb_el;

    TamponEntiers(int capa) {
	tab = new int[capa];
	active_size = capa;
	nb_el = 0;
    }

    private void agrandir() throws SaturationMemoireException
    {
	int i;
	int new_size;
	new_size = active_size * 2;
	try 
	    {
		int[] tab_aux = new int[new_size];
		for (i=0; i<active_size; i++) 
		    {
			tab_aux[i] = tab[i];
		    }
		tab = tab_aux;
		active_size = new_size;
	    }
	catch (OutOfMemoryError e)
	    {
		throw new SaturationMemoireException("trop plein de mmoire");
	    }
    }

    public void ajouter(int element) throws SaturationMemoireException
    {
	/*System.out.println(nb_el);*/
	try
	    {
		tab[nb_el] = element;
	    }
	catch(Exception e)
	    {
		agrandir();
		tab[nb_el] = element;
	    }
	nb_el = nb_el+1;
	//System.out.println("ai ajout "+element); 
    }

    
    public void vider() {
	nb_el = 0;
    }

    public void imprimer() {
	int i;
	for (i=0;i<this.nbElements();i++){
	    System.out.println("case : "+i+", el : "+this.element(i));
	}

    }

    public int element(int indice) {
	return tab[indice];
    }

    
    public int nbElements() {
	return nb_el;
    }


}

